/*
 * GMS REST API
 * Date: 2019-02-01 10:39:51 | Number of web services: 177
 *
 * OpenAPI spec version: 3.1.0-alpha.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.google.gson.reflect.TypeToken;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;
import io.swagger.client.model.EndDeviceDto;
import io.swagger.client.model.EndDeviceLastGatewayDto;
import io.swagger.client.model.EndDeviceMessageDto;
import io.swagger.client.model.EndDevicePositionDto;
import io.swagger.client.model.GatewayPositionDto;
import io.swagger.client.model.KpiDto;
import io.swagger.client.model.LnsEventDto;
import io.swagger.client.model.MacCommandDto;
import io.swagger.client.model.PaginatedDto;
import io.swagger.client.model.ProgressMonitorDto;

public class EndDevicesApi {
    private ApiClient apiClient;

    public EndDevicesApi() {
        this(Configuration.getDefaultApiClient());
    }

    public EndDevicesApi(final ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return this.apiClient;
    }

    public void setApiClient(final ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for createEndDevices
     * @param file  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createEndDevicesCall(final File file, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/bulk";

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();
        if (file != null) {
			localVarFormParams.put("file", file);
		}

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            "multipart/form-data"
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createEndDevicesValidateBeforeCall(final File file, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = createEndDevicesCall(file, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createEndDevices
     * This web service allows to create a list of end-devices from a CSV file. The CSV file contains a list of CsvEndDeviceDto.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response and the header Location allows to request for the progress monitoring returned by the web service getCreateEndDevicesStatus&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer of each end-device (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param file  (optional)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String createEndDevices(final File file) throws ApiException {
        ApiResponse<String> resp = createEndDevicesWithHttpInfo(file);
        return resp.getData();
    }

    /**
     * createEndDevices
     * This web service allows to create a list of end-devices from a CSV file. The CSV file contains a list of CsvEndDeviceDto.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response and the header Location allows to request for the progress monitoring returned by the web service getCreateEndDevicesStatus&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer of each end-device (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param file  (optional)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> createEndDevicesWithHttpInfo(final File file) throws ApiException {
        com.squareup.okhttp.Call call = createEndDevicesValidateBeforeCall(file, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * createEndDevices (asynchronously)
     * This web service allows to create a list of end-devices from a CSV file. The CSV file contains a list of CsvEndDeviceDto.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response and the header Location allows to request for the progress monitoring returned by the web service getCreateEndDevicesStatus&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer of each end-device (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param file  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createEndDevicesAsync(final File file, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createEndDevicesValidateBeforeCall(file, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createEndDevicesDeletion
     * @param body The list of end-devices devEui (exemple : [&quot;AAAAAAAAAAAAAA16&quot;,&quot;BBBBBBBBBBBBBB16&quot;,&quot;CCCCCCCCCCCCCC16&quot;]) (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createEndDevicesDeletionCall(final List<String> body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/deletions";

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createEndDevicesDeletionValidateBeforeCall(final List<String> body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling createEndDevicesDeletion(Async)");
        }
        
        com.squareup.okhttp.Call call = createEndDevicesDeletionCall(body, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createEndDevicesDeletion
     * This web service allows to delete a list of end-devices.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response status.&lt;br&gt;The response header Content-Location allows to poll the ProgressMonitorDto with the web service getEndDevicesDeletion.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The list of end-devices devEui (exemple : [&quot;AAAAAAAAAAAAAA16&quot;,&quot;BBBBBBBBBBBBBB16&quot;,&quot;CCCCCCCCCCCCCC16&quot;]) (required)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String createEndDevicesDeletion(final List<String> body) throws ApiException {
        ApiResponse<String> resp = createEndDevicesDeletionWithHttpInfo(body);
        return resp.getData();
    }

    /**
     * createEndDevicesDeletion
     * This web service allows to delete a list of end-devices.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response status.&lt;br&gt;The response header Content-Location allows to poll the ProgressMonitorDto with the web service getEndDevicesDeletion.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The list of end-devices devEui (exemple : [&quot;AAAAAAAAAAAAAA16&quot;,&quot;BBBBBBBBBBBBBB16&quot;,&quot;CCCCCCCCCCCCCC16&quot;]) (required)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> createEndDevicesDeletionWithHttpInfo(final List<String> body) throws ApiException {
        com.squareup.okhttp.Call call = createEndDevicesDeletionValidateBeforeCall(body, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * createEndDevicesDeletion (asynchronously)
     * This web service allows to delete a list of end-devices.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response status.&lt;br&gt;The response header Content-Location allows to poll the ProgressMonitorDto with the web service getEndDevicesDeletion.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The list of end-devices devEui (exemple : [&quot;AAAAAAAAAAAAAA16&quot;,&quot;BBBBBBBBBBBBBB16&quot;,&quot;CCCCCCCCCCCCCC16&quot;]) (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createEndDevicesDeletionAsync(final List<String> body, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createEndDevicesDeletionValidateBeforeCall(body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createEndDevicesExport
     * @param fields List of fields to display (optional)
     * @param importable true means that csv is importable from web service createEndDevices. (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createEndDevicesExportCall(final String fields, final Boolean importable, final String search, final String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/exports";

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();
        if (fields != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("fields", fields));
		}
        if (importable != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("importable", importable));
		}
        if (search != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("search", search));
		}
        if (sort != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("sort", sort));
		}

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createEndDevicesExportValidateBeforeCall(final String fields, final Boolean importable, final String search, final String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = createEndDevicesExportCall(fields, importable, search, sort, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createEndDevicesExport
     * This web service allows to export all the end-devices to a CSV file.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response status.&lt;br&gt;The response header Content-Location allows to poll the ProgressMonitorDto with the web service getEndDevicesExport.&lt;br&gt;The parameters sort and search refer to a EndDeviceDto.&lt;br&gt;The generated CSV file is a list of CsvEndDeviceDto.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;li&gt;If the connected user is SUPER_ADMIN then all end-devices are exported, otherwise only the end-devices attached to his customer.&lt;/li&gt;&lt;li&gt;If the parameter importable is set to true, then the csv file will contain only the authorized fields of a CsvEndDeviceDto.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param importable true means that csv is importable from web service createEndDevices. (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String createEndDevicesExport(final String fields, final Boolean importable, final String search, final String sort) throws ApiException {
        ApiResponse<String> resp = createEndDevicesExportWithHttpInfo(fields, importable, search, sort);
        return resp.getData();
    }

    /**
     * createEndDevicesExport
     * This web service allows to export all the end-devices to a CSV file.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response status.&lt;br&gt;The response header Content-Location allows to poll the ProgressMonitorDto with the web service getEndDevicesExport.&lt;br&gt;The parameters sort and search refer to a EndDeviceDto.&lt;br&gt;The generated CSV file is a list of CsvEndDeviceDto.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;li&gt;If the connected user is SUPER_ADMIN then all end-devices are exported, otherwise only the end-devices attached to his customer.&lt;/li&gt;&lt;li&gt;If the parameter importable is set to true, then the csv file will contain only the authorized fields of a CsvEndDeviceDto.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param importable true means that csv is importable from web service createEndDevices. (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> createEndDevicesExportWithHttpInfo(final String fields, final Boolean importable, final String search, final String sort) throws ApiException {
        com.squareup.okhttp.Call call = createEndDevicesExportValidateBeforeCall(fields, importable, search, sort, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * createEndDevicesExport (asynchronously)
     * This web service allows to export all the end-devices to a CSV file.&lt;br&gt;This web service is asynchronous. It sends a 202 Accepted response status.&lt;br&gt;The response header Content-Location allows to poll the ProgressMonitorDto with the web service getEndDevicesExport.&lt;br&gt;The parameters sort and search refer to a EndDeviceDto.&lt;br&gt;The generated CSV file is a list of CsvEndDeviceDto.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;li&gt;If the connected user is SUPER_ADMIN then all end-devices are exported, otherwise only the end-devices attached to his customer.&lt;/li&gt;&lt;li&gt;If the parameter importable is set to true, then the csv file will contain only the authorized fields of a CsvEndDeviceDto.&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param importable true means that csv is importable from web service createEndDevices. (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createEndDevicesExportAsync(final String fields, final Boolean importable, final String search, final String sort, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createEndDevicesExportValidateBeforeCall(fields, importable, search, sort, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for createMacCommand
     * @param body The DTO JSON representation to put in the request body (required)
     * @param devEui Identifier (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createMacCommandCall(final MacCommandDto body, final String devEui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/{devEui}/macCommands"
            .replaceAll("\\{" + "devEui" + "\\}", this.apiClient.escapeString(devEui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createMacCommandValidateBeforeCall(final MacCommandDto body, final String devEui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling createMacCommand(Async)");
        }
        // verify the required parameter 'devEui' is set
        if (devEui == null) {
            throw new ApiException("Missing the required parameter 'devEui' when calling createMacCommand(Async)");
        }
        
        com.squareup.okhttp.Call call = createMacCommandCall(body, devEui, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * createMacCommand
     * This web service allows to create a new mac command.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v3.1.0&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param devEui Identifier (required)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String createMacCommand(final MacCommandDto body, final String devEui) throws ApiException {
        ApiResponse<String> resp = createMacCommandWithHttpInfo(body, devEui);
        return resp.getData();
    }

    /**
     * createMacCommand
     * This web service allows to create a new mac command.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v3.1.0&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param devEui Identifier (required)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> createMacCommandWithHttpInfo(final MacCommandDto body, final String devEui) throws ApiException {
        com.squareup.okhttp.Call call = createMacCommandValidateBeforeCall(body, devEui, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * createMacCommand (asynchronously)
     * This web service allows to create a new mac command.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v3.1.0&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param devEui Identifier (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createMacCommandAsync(final MacCommandDto body, final String devEui, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createMacCommandValidateBeforeCall(body, devEui, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for deleteEndDevice
     * @param devEui End-device EUI (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call deleteEndDeviceCall(final String devEui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/{devEui}"
            .replaceAll("\\{" + "devEui" + "\\}", this.apiClient.escapeString(devEui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call deleteEndDeviceValidateBeforeCall(final String devEui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'devEui' is set
        if (devEui == null) {
            throw new ApiException("Missing the required parameter 'devEui' when calling deleteEndDevice(Async)");
        }
        
        com.squareup.okhttp.Call call = deleteEndDeviceCall(devEui, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * deleteEndDevice
     * This web service allows to delete an end-device.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void deleteEndDevice(final String devEui) throws ApiException {
        deleteEndDeviceWithHttpInfo(devEui);
    }

    /**
     * deleteEndDevice
     * This web service allows to delete an end-device.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> deleteEndDeviceWithHttpInfo(final String devEui) throws ApiException {
        com.squareup.okhttp.Call call = deleteEndDeviceValidateBeforeCall(devEui, null, null);
        return this.apiClient.execute(call);
    }

    /**
     * deleteEndDevice (asynchronously)
     * This web service allows to delete an end-device.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call deleteEndDeviceAsync(final String devEui, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = deleteEndDeviceValidateBeforeCall(devEui, progressListener, progressRequestListener);
        this.apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for getCreateEndDevicesStatus
     * @param id Bulk identifier (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getCreateEndDevicesStatusCall(final String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/bulk/{id}"
            .replaceAll("\\{" + "id" + "\\}", this.apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getCreateEndDevicesStatusValidateBeforeCall(final String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getCreateEndDevicesStatus(Async)");
        }
        
        com.squareup.okhttp.Call call = getCreateEndDevicesStatusCall(id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getCreateEndDevicesStatus
     * This web service allows to retrieve the status of a createEndDevices web service execution.&lt;br&gt;If errors occur, the progressMonitor field result contains the lines in error.&lt;br&gt;&lt;br&gt;Since: v2.1.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param id Bulk identifier (required)
     * @return ProgressMonitorDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProgressMonitorDto getCreateEndDevicesStatus(final String id) throws ApiException {
        ApiResponse<ProgressMonitorDto> resp = getCreateEndDevicesStatusWithHttpInfo(id);
        return resp.getData();
    }

    /**
     * getCreateEndDevicesStatus
     * This web service allows to retrieve the status of a createEndDevices web service execution.&lt;br&gt;If errors occur, the progressMonitor field result contains the lines in error.&lt;br&gt;&lt;br&gt;Since: v2.1.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param id Bulk identifier (required)
     * @return ApiResponse&lt;ProgressMonitorDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProgressMonitorDto> getCreateEndDevicesStatusWithHttpInfo(final String id) throws ApiException {
        com.squareup.okhttp.Call call = getCreateEndDevicesStatusValidateBeforeCall(id, null, null);
        Type localVarReturnType = new TypeToken<ProgressMonitorDto>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * getCreateEndDevicesStatus (asynchronously)
     * This web service allows to retrieve the status of a createEndDevices web service execution.&lt;br&gt;If errors occur, the progressMonitor field result contains the lines in error.&lt;br&gt;&lt;br&gt;Since: v2.1.0&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param id Bulk identifier (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getCreateEndDevicesStatusAsync(final String id, final ApiCallback<ProgressMonitorDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getCreateEndDevicesStatusValidateBeforeCall(id, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProgressMonitorDto>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getEndDevice
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getEndDeviceCall(final String devEui, final String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/{devEui}"
            .replaceAll("\\{" + "devEui" + "\\}", this.apiClient.escapeString(devEui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();
        if (fields != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("fields", fields));
		}

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getEndDeviceValidateBeforeCall(final String devEui, final String fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'devEui' is set
        if (devEui == null) {
            throw new ApiException("Missing the required parameter 'devEui' when calling getEndDevice(Async)");
        }
        
        com.squareup.okhttp.Call call = getEndDeviceCall(devEui, fields, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getEndDevice
     * This web service allows to retrieve an end-device.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @return EndDeviceDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public EndDeviceDto getEndDevice(final String devEui, final String fields) throws ApiException {
        ApiResponse<EndDeviceDto> resp = getEndDeviceWithHttpInfo(devEui, fields);
        return resp.getData();
    }

    /**
     * getEndDevice
     * This web service allows to retrieve an end-device.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @return ApiResponse&lt;EndDeviceDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<EndDeviceDto> getEndDeviceWithHttpInfo(final String devEui, final String fields) throws ApiException {
        com.squareup.okhttp.Call call = getEndDeviceValidateBeforeCall(devEui, fields, null, null);
        Type localVarReturnType = new TypeToken<EndDeviceDto>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * getEndDevice (asynchronously)
     * This web service allows to retrieve an end-device.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getEndDeviceAsync(final String devEui, final String fields, final ApiCallback<EndDeviceDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getEndDeviceValidateBeforeCall(devEui, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<EndDeviceDto>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getEndDeviceEvents
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getEndDeviceEventsCall(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/{devEui}/events"
            .replaceAll("\\{" + "devEui" + "\\}", this.apiClient.escapeString(devEui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();
        if (fields != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("fields", fields));
		}
        if (page != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("page", page));
		}
        if (pageSize != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("pageSize", pageSize));
		}
        if (search != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("search", search));
		}
        if (sort != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("sort", sort));
		}

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getEndDeviceEventsValidateBeforeCall(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'devEui' is set
        if (devEui == null) {
            throw new ApiException("Missing the required parameter 'devEui' when calling getEndDeviceEvents(Async)");
        }
        
        com.squareup.okhttp.Call call = getEndDeviceEventsCall(devEui, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getEndDeviceEvents
     * This web service allows to retrieve the LNS events of one end-device.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<LnsEventDto> getEndDeviceEvents(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort) throws ApiException {
        ApiResponse<PaginatedDto<LnsEventDto>> resp = getEndDeviceEventsWithHttpInfo(devEui, fields, page, pageSize, search, sort);
        return resp.getData();
    }

    /**
     * getEndDeviceEvents
     * This web service allows to retrieve the LNS events of one end-device.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<LnsEventDto>> getEndDeviceEventsWithHttpInfo(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort) throws ApiException {
        com.squareup.okhttp.Call call = getEndDeviceEventsValidateBeforeCall(devEui, fields, page, pageSize, search, sort, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<LnsEventDto>>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * getEndDeviceEvents (asynchronously)
     * This web service allows to retrieve the LNS events of one end-device.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getEndDeviceEventsAsync(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort, final ApiCallback<PaginatedDto<LnsEventDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getEndDeviceEventsValidateBeforeCall(devEui, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<LnsEventDto>>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getEndDeviceGatewaysPositions
     * @param devEui Identifier (required)
     * @param fields List of fields to display (optional)
     * @param maxTimestamp Maximum timestamp. Default value is 2147483646 (optional)
     * @param minTimestamp Minimum timestamp. Default value is 0 (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param processingId Processing identifier (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getEndDeviceGatewaysPositionsCall(final String devEui, final String fields, final Long maxTimestamp, final Long minTimestamp, final String page, final String pageSize, final Long processingId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/{devEui}/positions/gateways"
            .replaceAll("\\{" + "devEui" + "\\}", this.apiClient.escapeString(devEui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();
        if (fields != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("fields", fields));
		}
        if (maxTimestamp != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("maxTimestamp", maxTimestamp));
		}
        if (minTimestamp != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("minTimestamp", minTimestamp));
		}
        if (page != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("page", page));
		}
        if (pageSize != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("pageSize", pageSize));
		}
        if (processingId != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("processingId", processingId));
		}

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getEndDeviceGatewaysPositionsValidateBeforeCall(final String devEui, final String fields, final Long maxTimestamp, final Long minTimestamp, final String page, final String pageSize, final Long processingId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'devEui' is set
        if (devEui == null) {
            throw new ApiException("Missing the required parameter 'devEui' when calling getEndDeviceGatewaysPositions(Async)");
        }
        
        com.squareup.okhttp.Call call = getEndDeviceGatewaysPositionsCall(devEui, fields, maxTimestamp, minTimestamp, page, pageSize, processingId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getEndDeviceGatewaysPositions
     * This web service allows to retrieve the list of positions of the gateways which have routed an endDevice.&lt;br&gt;Although it returns a paginatedDto, this web service is not paginated. All the results are returned within the same page.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v3.1.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui Identifier (required)
     * @param fields List of fields to display (optional)
     * @param maxTimestamp Maximum timestamp. Default value is 2147483646 (optional)
     * @param minTimestamp Minimum timestamp. Default value is 0 (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param processingId Processing identifier (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<GatewayPositionDto> getEndDeviceGatewaysPositions(final String devEui, final String fields, final Long maxTimestamp, final Long minTimestamp, final String page, final String pageSize, final Long processingId) throws ApiException {
        ApiResponse<PaginatedDto<GatewayPositionDto>> resp = getEndDeviceGatewaysPositionsWithHttpInfo(devEui, fields, maxTimestamp, minTimestamp, page, pageSize, processingId);
        return resp.getData();
    }

    /**
     * getEndDeviceGatewaysPositions
     * This web service allows to retrieve the list of positions of the gateways which have routed an endDevice.&lt;br&gt;Although it returns a paginatedDto, this web service is not paginated. All the results are returned within the same page.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v3.1.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui Identifier (required)
     * @param fields List of fields to display (optional)
     * @param maxTimestamp Maximum timestamp. Default value is 2147483646 (optional)
     * @param minTimestamp Minimum timestamp. Default value is 0 (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param processingId Processing identifier (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<GatewayPositionDto>> getEndDeviceGatewaysPositionsWithHttpInfo(final String devEui, final String fields, final Long maxTimestamp, final Long minTimestamp, final String page, final String pageSize, final Long processingId) throws ApiException {
        com.squareup.okhttp.Call call = getEndDeviceGatewaysPositionsValidateBeforeCall(devEui, fields, maxTimestamp, minTimestamp, page, pageSize, processingId, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayPositionDto>>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * getEndDeviceGatewaysPositions (asynchronously)
     * This web service allows to retrieve the list of positions of the gateways which have routed an endDevice.&lt;br&gt;Although it returns a paginatedDto, this web service is not paginated. All the results are returned within the same page.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v3.1.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui Identifier (required)
     * @param fields List of fields to display (optional)
     * @param maxTimestamp Maximum timestamp. Default value is 2147483646 (optional)
     * @param minTimestamp Minimum timestamp. Default value is 0 (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param processingId Processing identifier (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getEndDeviceGatewaysPositionsAsync(final String devEui, final String fields, final Long maxTimestamp, final Long minTimestamp, final String page, final String pageSize, final Long processingId, final ApiCallback<PaginatedDto<GatewayPositionDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getEndDeviceGatewaysPositionsValidateBeforeCall(devEui, fields, maxTimestamp, minTimestamp, page, pageSize, processingId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<GatewayPositionDto>>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getEndDeviceLastEvents
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getEndDeviceLastEventsCall(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/{devEui}/events/last"
            .replaceAll("\\{" + "devEui" + "\\}", this.apiClient.escapeString(devEui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();
        if (fields != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("fields", fields));
		}
        if (page != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("page", page));
		}
        if (pageSize != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("pageSize", pageSize));
		}
        if (search != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("search", search));
		}
        if (sort != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("sort", sort));
		}

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getEndDeviceLastEventsValidateBeforeCall(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'devEui' is set
        if (devEui == null) {
            throw new ApiException("Missing the required parameter 'devEui' when calling getEndDeviceLastEvents(Async)");
        }
        
        com.squareup.okhttp.Call call = getEndDeviceLastEventsCall(devEui, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getEndDeviceLastEvents
     * This web service allows to retrieve the LNS last events of one end-device.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<LnsEventDto> getEndDeviceLastEvents(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort) throws ApiException {
        ApiResponse<PaginatedDto<LnsEventDto>> resp = getEndDeviceLastEventsWithHttpInfo(devEui, fields, page, pageSize, search, sort);
        return resp.getData();
    }

    /**
     * getEndDeviceLastEvents
     * This web service allows to retrieve the LNS last events of one end-device.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<LnsEventDto>> getEndDeviceLastEventsWithHttpInfo(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort) throws ApiException {
        com.squareup.okhttp.Call call = getEndDeviceLastEventsValidateBeforeCall(devEui, fields, page, pageSize, search, sort, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<LnsEventDto>>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * getEndDeviceLastEvents (asynchronously)
     * This web service allows to retrieve the LNS last events of one end-device.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN).&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getEndDeviceLastEventsAsync(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort, final ApiCallback<PaginatedDto<LnsEventDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getEndDeviceLastEventsValidateBeforeCall(devEui, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<LnsEventDto>>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getEndDeviceLastGateways
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getEndDeviceLastGatewaysCall(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/{devEui}/gateways/last"
            .replaceAll("\\{" + "devEui" + "\\}", this.apiClient.escapeString(devEui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();
        if (fields != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("fields", fields));
		}
        if (page != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("page", page));
		}
        if (pageSize != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("pageSize", pageSize));
		}
        if (search != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("search", search));
		}
        if (sort != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("sort", sort));
		}

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getEndDeviceLastGatewaysValidateBeforeCall(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'devEui' is set
        if (devEui == null) {
            throw new ApiException("Missing the required parameter 'devEui' when calling getEndDeviceLastGateways(Async)");
        }
        
        com.squareup.okhttp.Call call = getEndDeviceLastGatewaysCall(devEui, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getEndDeviceLastGateways
     * This web service allows to get the gateways which have seen the end-device.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<EndDeviceLastGatewayDto> getEndDeviceLastGateways(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort) throws ApiException {
        ApiResponse<PaginatedDto<EndDeviceLastGatewayDto>> resp = getEndDeviceLastGatewaysWithHttpInfo(devEui, fields, page, pageSize, search, sort);
        return resp.getData();
    }

    /**
     * getEndDeviceLastGateways
     * This web service allows to get the gateways which have seen the end-device.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<EndDeviceLastGatewayDto>> getEndDeviceLastGatewaysWithHttpInfo(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort) throws ApiException {
        com.squareup.okhttp.Call call = getEndDeviceLastGatewaysValidateBeforeCall(devEui, fields, page, pageSize, search, sort, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<EndDeviceLastGatewayDto>>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * getEndDeviceLastGateways (asynchronously)
     * This web service allows to get the gateways which have seen the end-device.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getEndDeviceLastGatewaysAsync(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort, final ApiCallback<PaginatedDto<EndDeviceLastGatewayDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getEndDeviceLastGatewaysValidateBeforeCall(devEui, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<EndDeviceLastGatewayDto>>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getEndDeviceMessages
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getEndDeviceMessagesCall(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/{devEui}/messages"
            .replaceAll("\\{" + "devEui" + "\\}", this.apiClient.escapeString(devEui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();
        if (fields != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("fields", fields));
		}
        if (page != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("page", page));
		}
        if (pageSize != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("pageSize", pageSize));
		}
        if (search != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("search", search));
		}
        if (sort != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("sort", sort));
		}

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getEndDeviceMessagesValidateBeforeCall(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'devEui' is set
        if (devEui == null) {
            throw new ApiException("Missing the required parameter 'devEui' when calling getEndDeviceMessages(Async)");
        }
        
        com.squareup.okhttp.Call call = getEndDeviceMessagesCall(devEui, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getEndDeviceMessages
     * This web service allows to retrieve the messages of one end-device.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<EndDeviceMessageDto> getEndDeviceMessages(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort) throws ApiException {
        ApiResponse<PaginatedDto<EndDeviceMessageDto>> resp = getEndDeviceMessagesWithHttpInfo(devEui, fields, page, pageSize, search, sort);
        return resp.getData();
    }

    /**
     * getEndDeviceMessages
     * This web service allows to retrieve the messages of one end-device.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<EndDeviceMessageDto>> getEndDeviceMessagesWithHttpInfo(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort) throws ApiException {
        com.squareup.okhttp.Call call = getEndDeviceMessagesValidateBeforeCall(devEui, fields, page, pageSize, search, sort, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<EndDeviceMessageDto>>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * getEndDeviceMessages (asynchronously)
     * This web service allows to retrieve the messages of one end-device.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getEndDeviceMessagesAsync(final String devEui, final String fields, final String page, final String pageSize, final String search, final String sort, final ApiCallback<PaginatedDto<EndDeviceMessageDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getEndDeviceMessagesValidateBeforeCall(devEui, fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<EndDeviceMessageDto>>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getEndDevicePositions
     * @param devEui End-device EUI (required)
     * @param algorithm The algorithm (optional)
     * @param fields List of fields to display (optional)
     * @param gpsDist GPS dist. Default value is false (optional)
     * @param maxTimestamp Maximum timestamp. Default value is 2147483646 (optional)
     * @param method Method (optional)
     * @param minTimestamp Minimum timestamp. Default value is 0 (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getEndDevicePositionsCall(final String devEui, final String algorithm, final String fields, final Boolean gpsDist, final Long maxTimestamp, final String method, final Long minTimestamp, final String page, final String pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/{devEui}/positions"
            .replaceAll("\\{" + "devEui" + "\\}", this.apiClient.escapeString(devEui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();
        if (algorithm != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("algorithm", algorithm));
		}
        if (fields != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("fields", fields));
		}
        if (gpsDist != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("gpsDist", gpsDist));
		}
        if (maxTimestamp != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("maxTimestamp", maxTimestamp));
		}
        if (method != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("method", method));
		}
        if (minTimestamp != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("minTimestamp", minTimestamp));
		}
        if (page != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("page", page));
		}
        if (pageSize != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("pageSize", pageSize));
		}

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getEndDevicePositionsValidateBeforeCall(final String devEui, final String algorithm, final String fields, final Boolean gpsDist, final Long maxTimestamp, final String method, final Long minTimestamp, final String page, final String pageSize, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'devEui' is set
        if (devEui == null) {
            throw new ApiException("Missing the required parameter 'devEui' when calling getEndDevicePositions(Async)");
        }
        
        com.squareup.okhttp.Call call = getEndDevicePositionsCall(devEui, algorithm, fields, gpsDist, maxTimestamp, method, minTimestamp, page, pageSize, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getEndDevicePositions
     * This web service allows to get the positions of an end-device.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param algorithm The algorithm (optional)
     * @param fields List of fields to display (optional)
     * @param gpsDist GPS dist. Default value is false (optional)
     * @param maxTimestamp Maximum timestamp. Default value is 2147483646 (optional)
     * @param method Method (optional)
     * @param minTimestamp Minimum timestamp. Default value is 0 (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<EndDevicePositionDto> getEndDevicePositions(final String devEui, final String algorithm, final String fields, final Boolean gpsDist, final Long maxTimestamp, final String method, final Long minTimestamp, final String page, final String pageSize) throws ApiException {
        ApiResponse<PaginatedDto<EndDevicePositionDto>> resp = getEndDevicePositionsWithHttpInfo(devEui, algorithm, fields, gpsDist, maxTimestamp, method, minTimestamp, page, pageSize);
        return resp.getData();
    }

    /**
     * getEndDevicePositions
     * This web service allows to get the positions of an end-device.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param algorithm The algorithm (optional)
     * @param fields List of fields to display (optional)
     * @param gpsDist GPS dist. Default value is false (optional)
     * @param maxTimestamp Maximum timestamp. Default value is 2147483646 (optional)
     * @param method Method (optional)
     * @param minTimestamp Minimum timestamp. Default value is 0 (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<EndDevicePositionDto>> getEndDevicePositionsWithHttpInfo(final String devEui, final String algorithm, final String fields, final Boolean gpsDist, final Long maxTimestamp, final String method, final Long minTimestamp, final String page, final String pageSize) throws ApiException {
        com.squareup.okhttp.Call call = getEndDevicePositionsValidateBeforeCall(devEui, algorithm, fields, gpsDist, maxTimestamp, method, minTimestamp, page, pageSize, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<EndDevicePositionDto>>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * getEndDevicePositions (asynchronously)
     * This web service allows to get the positions of an end-device.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param algorithm The algorithm (optional)
     * @param fields List of fields to display (optional)
     * @param gpsDist GPS dist. Default value is false (optional)
     * @param maxTimestamp Maximum timestamp. Default value is 2147483646 (optional)
     * @param method Method (optional)
     * @param minTimestamp Minimum timestamp. Default value is 0 (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getEndDevicePositionsAsync(final String devEui, final String algorithm, final String fields, final Boolean gpsDist, final Long maxTimestamp, final String method, final Long minTimestamp, final String page, final String pageSize, final ApiCallback<PaginatedDto<EndDevicePositionDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getEndDevicePositionsValidateBeforeCall(devEui, algorithm, fields, gpsDist, maxTimestamp, method, minTimestamp, page, pageSize, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<EndDevicePositionDto>>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getEndDevices
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getEndDevicesCall(final String fields, final String page, final String pageSize, final String search, final String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices";

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();
        if (fields != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("fields", fields));
		}
        if (page != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("page", page));
		}
        if (pageSize != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("pageSize", pageSize));
		}
        if (search != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("search", search));
		}
        if (sort != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("sort", sort));
		}

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getEndDevicesValidateBeforeCall(final String fields, final String page, final String pageSize, final String search, final String sort, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = getEndDevicesCall(fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getEndDevices
     * This web service allows to retrieve the list of end-devices.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<EndDeviceDto> getEndDevices(final String fields, final String page, final String pageSize, final String search, final String sort) throws ApiException {
        ApiResponse<PaginatedDto<EndDeviceDto>> resp = getEndDevicesWithHttpInfo(fields, page, pageSize, search, sort);
        return resp.getData();
    }

    /**
     * getEndDevices
     * This web service allows to retrieve the list of end-devices.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<EndDeviceDto>> getEndDevicesWithHttpInfo(final String fields, final String page, final String pageSize, final String search, final String sort) throws ApiException {
        com.squareup.okhttp.Call call = getEndDevicesValidateBeforeCall(fields, page, pageSize, search, sort, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<EndDeviceDto>>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * getEndDevices (asynchronously)
     * This web service allows to retrieve the list of end-devices.&lt;br&gt;&lt;br&gt;Rules:&lt;ul&gt;&lt;li&gt;The connected user can manage the customer (he belongs to the customer or he is SUPER_ADMIN)&lt;/li&gt;&lt;/ul&gt;&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param fields List of fields to display (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param search Search condition (optional)
     * @param sort Sort value (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getEndDevicesAsync(final String fields, final String page, final String pageSize, final String search, final String sort, final ApiCallback<PaginatedDto<EndDeviceDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getEndDevicesValidateBeforeCall(fields, page, pageSize, search, sort, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<EndDeviceDto>>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getEndDevicesDeletion
     * @param id Deletion identifier (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getEndDevicesDeletionCall(final String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/deletions/{id}"
            .replaceAll("\\{" + "id" + "\\}", this.apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getEndDevicesDeletionValidateBeforeCall(final String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getEndDevicesDeletion(Async)");
        }
        
        com.squareup.okhttp.Call call = getEndDevicesDeletionCall(id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getEndDevicesDeletion
     * This web service allows to retrieve the progress monitor of the createEndDevicesDeletion web service.&lt;br&gt;Purge: The monitor is purged 2 days after the last access. If the monitor is never accessed, it will be purged after 2 days.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param id Deletion identifier (required)
     * @return ProgressMonitorDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProgressMonitorDto getEndDevicesDeletion(final String id) throws ApiException {
        ApiResponse<ProgressMonitorDto> resp = getEndDevicesDeletionWithHttpInfo(id);
        return resp.getData();
    }

    /**
     * getEndDevicesDeletion
     * This web service allows to retrieve the progress monitor of the createEndDevicesDeletion web service.&lt;br&gt;Purge: The monitor is purged 2 days after the last access. If the monitor is never accessed, it will be purged after 2 days.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param id Deletion identifier (required)
     * @return ApiResponse&lt;ProgressMonitorDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProgressMonitorDto> getEndDevicesDeletionWithHttpInfo(final String id) throws ApiException {
        com.squareup.okhttp.Call call = getEndDevicesDeletionValidateBeforeCall(id, null, null);
        Type localVarReturnType = new TypeToken<ProgressMonitorDto>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * getEndDevicesDeletion (asynchronously)
     * This web service allows to retrieve the progress monitor of the createEndDevicesDeletion web service.&lt;br&gt;Purge: The monitor is purged 2 days after the last access. If the monitor is never accessed, it will be purged after 2 days.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param id Deletion identifier (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getEndDevicesDeletionAsync(final String id, final ApiCallback<ProgressMonitorDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getEndDevicesDeletionValidateBeforeCall(id, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProgressMonitorDto>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getEndDevicesExport
     * @param id Export identifier (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getEndDevicesExportCall(final String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/exports/{id}"
            .replaceAll("\\{" + "id" + "\\}", this.apiClient.escapeString(id.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getEndDevicesExportValidateBeforeCall(final String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getEndDevicesExport(Async)");
        }
        
        com.squareup.okhttp.Call call = getEndDevicesExportCall(id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getEndDevicesExport
     * This web service allows to get the progress monitor of the end-devices export web service (createEndDevicesExport).&lt;br&gt;When the progress monitor is terminated, one or two links are created depending on the status:&lt;br&gt;- Link with a rel field called success for the successfuly exported end-devices&lt;br&gt;- Link with a rel field called failed for the exported end-devices with errors&lt;br&gt;Purge: The monitor is purged 2 days after the last access. If the monitor is never accessed, it will be purged after 2 days.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Export identifier (required)
     * @return ProgressMonitorDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ProgressMonitorDto getEndDevicesExport(final String id) throws ApiException {
        ApiResponse<ProgressMonitorDto> resp = getEndDevicesExportWithHttpInfo(id);
        return resp.getData();
    }

    /**
     * getEndDevicesExport
     * This web service allows to get the progress monitor of the end-devices export web service (createEndDevicesExport).&lt;br&gt;When the progress monitor is terminated, one or two links are created depending on the status:&lt;br&gt;- Link with a rel field called success for the successfuly exported end-devices&lt;br&gt;- Link with a rel field called failed for the exported end-devices with errors&lt;br&gt;Purge: The monitor is purged 2 days after the last access. If the monitor is never accessed, it will be purged after 2 days.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Export identifier (required)
     * @return ApiResponse&lt;ProgressMonitorDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ProgressMonitorDto> getEndDevicesExportWithHttpInfo(final String id) throws ApiException {
        com.squareup.okhttp.Call call = getEndDevicesExportValidateBeforeCall(id, null, null);
        Type localVarReturnType = new TypeToken<ProgressMonitorDto>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * getEndDevicesExport (asynchronously)
     * This web service allows to get the progress monitor of the end-devices export web service (createEndDevicesExport).&lt;br&gt;When the progress monitor is terminated, one or two links are created depending on the status:&lt;br&gt;- Link with a rel field called success for the successfuly exported end-devices&lt;br&gt;- Link with a rel field called failed for the exported end-devices with errors&lt;br&gt;Purge: The monitor is purged 2 days after the last access. If the monitor is never accessed, it will be purged after 2 days.&lt;br&gt;&lt;br&gt;Since: v2.2.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param id Export identifier (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getEndDevicesExportAsync(final String id, final ApiCallback<ProgressMonitorDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getEndDevicesExportValidateBeforeCall(id, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ProgressMonitorDto>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getRncCustomerEndDeviceKpi
     * @param devEui End-device EUI (required)
     * @param kpi Kpi identifier from predefined set {DOWNLINK_BYTES, NB_DOWNLINK, NB_END_DEVICE, NB_UPLINK, PING, RSSI_UPLINK_MESSAGE, SNR_UPLINK_MESSAGE, TOA_DOWNLINK_MESSAGE, TOA_UPLINK_MESSAGE, UPLINK_BYTES} (required)
     * @param period Aggregation period from predefined set {DAY, HOUR, MINUTE, MONTH, WEEK, YEAR} (required)
     * @param activationType For kpi&#x3D;NB_END_DEVICE only Predefined set {ABP, OTAA} (optional)
     * @param frq For kpi&#x3D;TOA_UPLINK_MESSAGE only (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param sf For kpi&#x3D;TOA_UPLINK_MESSAGE only (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getRncCustomerEndDeviceKpiCall(final String devEui, final String kpi, final String period, final String activationType, final String frq, final String page, final String pageSize, final String sf, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/{devEui}/kpis/{kpi}"
            .replaceAll("\\{" + "devEui" + "\\}", this.apiClient.escapeString(devEui.toString()))
            .replaceAll("\\{" + "kpi" + "\\}", this.apiClient.escapeString(kpi.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();
        if (activationType != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("activationType", activationType));
		}
        if (frq != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("frq", frq));
		}
        if (page != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("page", page));
		}
        if (pageSize != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("pageSize", pageSize));
		}
        if (period != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("period", period));
		}
        if (sf != null) {
			localVarQueryParams.addAll(this.apiClient.parameterToPair("sf", sf));
		}

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getRncCustomerEndDeviceKpiValidateBeforeCall(final String devEui, final String kpi, final String period, final String activationType, final String frq, final String page, final String pageSize, final String sf, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'devEui' is set
        if (devEui == null) {
            throw new ApiException("Missing the required parameter 'devEui' when calling getRncCustomerEndDeviceKpi(Async)");
        }
        // verify the required parameter 'kpi' is set
        if (kpi == null) {
            throw new ApiException("Missing the required parameter 'kpi' when calling getRncCustomerEndDeviceKpi(Async)");
        }
        // verify the required parameter 'period' is set
        if (period == null) {
            throw new ApiException("Missing the required parameter 'period' when calling getRncCustomerEndDeviceKpi(Async)");
        }
        
        com.squareup.okhttp.Call call = getRncCustomerEndDeviceKpiCall(devEui, kpi, period, activationType, frq, page, pageSize, sf, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * getRncCustomerEndDeviceKpi
     * This web service returns a KPI by customer and end-device for one end-device.&lt;br&gt;&lt;br&gt;Since: v3.0.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param kpi Kpi identifier from predefined set {DOWNLINK_BYTES, NB_DOWNLINK, NB_END_DEVICE, NB_UPLINK, PING, RSSI_UPLINK_MESSAGE, SNR_UPLINK_MESSAGE, TOA_DOWNLINK_MESSAGE, TOA_UPLINK_MESSAGE, UPLINK_BYTES} (required)
     * @param period Aggregation period from predefined set {DAY, HOUR, MINUTE, MONTH, WEEK, YEAR} (required)
     * @param activationType For kpi&#x3D;NB_END_DEVICE only Predefined set {ABP, OTAA} (optional)
     * @param frq For kpi&#x3D;TOA_UPLINK_MESSAGE only (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param sf For kpi&#x3D;TOA_UPLINK_MESSAGE only (optional)
     * @return PaginatedDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public PaginatedDto<KpiDto> getRncCustomerEndDeviceKpi(final String devEui, final String kpi, final String period, final String activationType, final String frq, final String page, final String pageSize, final String sf) throws ApiException {
        ApiResponse<PaginatedDto<KpiDto>> resp = getRncCustomerEndDeviceKpiWithHttpInfo(devEui, kpi, period, activationType, frq, page, pageSize, sf);
        return resp.getData();
    }

    /**
     * getRncCustomerEndDeviceKpi
     * This web service returns a KPI by customer and end-device for one end-device.&lt;br&gt;&lt;br&gt;Since: v3.0.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param kpi Kpi identifier from predefined set {DOWNLINK_BYTES, NB_DOWNLINK, NB_END_DEVICE, NB_UPLINK, PING, RSSI_UPLINK_MESSAGE, SNR_UPLINK_MESSAGE, TOA_DOWNLINK_MESSAGE, TOA_UPLINK_MESSAGE, UPLINK_BYTES} (required)
     * @param period Aggregation period from predefined set {DAY, HOUR, MINUTE, MONTH, WEEK, YEAR} (required)
     * @param activationType For kpi&#x3D;NB_END_DEVICE only Predefined set {ABP, OTAA} (optional)
     * @param frq For kpi&#x3D;TOA_UPLINK_MESSAGE only (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param sf For kpi&#x3D;TOA_UPLINK_MESSAGE only (optional)
     * @return ApiResponse&lt;PaginatedDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<PaginatedDto<KpiDto>> getRncCustomerEndDeviceKpiWithHttpInfo(final String devEui, final String kpi, final String period, final String activationType, final String frq, final String page, final String pageSize, final String sf) throws ApiException {
        com.squareup.okhttp.Call call = getRncCustomerEndDeviceKpiValidateBeforeCall(devEui, kpi, period, activationType, frq, page, pageSize, sf, null, null);
        Type localVarReturnType = new TypeToken<PaginatedDto<KpiDto>>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * getRncCustomerEndDeviceKpi (asynchronously)
     * This web service returns a KPI by customer and end-device for one end-device.&lt;br&gt;&lt;br&gt;Since: v3.0.0&lt;br&gt;&lt;br&gt;Role ? READER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param kpi Kpi identifier from predefined set {DOWNLINK_BYTES, NB_DOWNLINK, NB_END_DEVICE, NB_UPLINK, PING, RSSI_UPLINK_MESSAGE, SNR_UPLINK_MESSAGE, TOA_DOWNLINK_MESSAGE, TOA_UPLINK_MESSAGE, UPLINK_BYTES} (required)
     * @param period Aggregation period from predefined set {DAY, HOUR, MINUTE, MONTH, WEEK, YEAR} (required)
     * @param activationType For kpi&#x3D;NB_END_DEVICE only Predefined set {ABP, OTAA} (optional)
     * @param frq For kpi&#x3D;TOA_UPLINK_MESSAGE only (optional)
     * @param page Page number (optional)
     * @param pageSize Page size value (optional)
     * @param sf For kpi&#x3D;TOA_UPLINK_MESSAGE only (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getRncCustomerEndDeviceKpiAsync(final String devEui, final String kpi, final String period, final String activationType, final String frq, final String page, final String pageSize, final String sf, final ApiCallback<PaginatedDto<KpiDto>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getRncCustomerEndDeviceKpiValidateBeforeCall(devEui, kpi, period, activationType, frq, page, pageSize, sf, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<PaginatedDto<KpiDto>>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for patchEndDevice
     * @param body The DTO JSON representation to put in the request body (required)
     * @param devEui End-device EUI (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call patchEndDeviceCall(final EndDeviceDto body, final String devEui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/{devEui}"
            .replaceAll("\\{" + "devEui" + "\\}", this.apiClient.escapeString(devEui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "PATCH", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call patchEndDeviceValidateBeforeCall(final EndDeviceDto body, final String devEui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling patchEndDevice(Async)");
        }
        // verify the required parameter 'devEui' is set
        if (devEui == null) {
            throw new ApiException("Missing the required parameter 'devEui' when calling patchEndDevice(Async)");
        }
        
        com.squareup.okhttp.Call call = patchEndDeviceCall(body, devEui, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * patchEndDevice
     * This web service allows to update an end-device.&lt;br&gt;Some fields of EndDeviceDto cannot be updated: activation, macVersion, rfRegion, regParamsRevision&lt;br&gt;Also depending on activation:&lt;br&gt;OTAA: appEui, appKey&lt;br&gt;ABP: devAddr, nwkSKey, appSKey&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param devEui End-device EUI (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void patchEndDevice(final EndDeviceDto body, final String devEui) throws ApiException {
        patchEndDeviceWithHttpInfo(body, devEui);
    }

    /**
     * patchEndDevice
     * This web service allows to update an end-device.&lt;br&gt;Some fields of EndDeviceDto cannot be updated: activation, macVersion, rfRegion, regParamsRevision&lt;br&gt;Also depending on activation:&lt;br&gt;OTAA: appEui, appKey&lt;br&gt;ABP: devAddr, nwkSKey, appSKey&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param devEui End-device EUI (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> patchEndDeviceWithHttpInfo(final EndDeviceDto body, final String devEui) throws ApiException {
        com.squareup.okhttp.Call call = patchEndDeviceValidateBeforeCall(body, devEui, null, null);
        return this.apiClient.execute(call);
    }

    /**
     * patchEndDevice (asynchronously)
     * This web service allows to update an end-device.&lt;br&gt;Some fields of EndDeviceDto cannot be updated: activation, macVersion, rfRegion, regParamsRevision&lt;br&gt;Also depending on activation:&lt;br&gt;OTAA: appEui, appKey&lt;br&gt;ABP: devAddr, nwkSKey, appSKey&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param devEui End-device EUI (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call patchEndDeviceAsync(final EndDeviceDto body, final String devEui, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = patchEndDeviceValidateBeforeCall(body, devEui, progressListener, progressRequestListener);
        this.apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for putEndDevice
     * @param body The DTO JSON representation to put in the request body (required)
     * @param devEui End-device EUI (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call putEndDeviceCall(final EndDeviceDto body, final String devEui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/{devEui}"
            .replaceAll("\\{" + "devEui" + "\\}", this.apiClient.escapeString(devEui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call putEndDeviceValidateBeforeCall(final EndDeviceDto body, final String devEui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling putEndDevice(Async)");
        }
        // verify the required parameter 'devEui' is set
        if (devEui == null) {
            throw new ApiException("Missing the required parameter 'devEui' when calling putEndDevice(Async)");
        }
        
        com.squareup.okhttp.Call call = putEndDeviceCall(body, devEui, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * putEndDevice
     * This web service allows to create or update an end-device.&lt;br&gt;It returns an HTTP status 201 Created when a new end-device is created and an HTTP status 204 No-Content when an existing end-device is updated.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param devEui End-device EUI (required)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String putEndDevice(final EndDeviceDto body, final String devEui) throws ApiException {
        ApiResponse<String> resp = putEndDeviceWithHttpInfo(body, devEui);
        return resp.getData();
    }

    /**
     * putEndDevice
     * This web service allows to create or update an end-device.&lt;br&gt;It returns an HTTP status 201 Created when a new end-device is created and an HTTP status 204 No-Content when an existing end-device is updated.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param devEui End-device EUI (required)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> putEndDeviceWithHttpInfo(final EndDeviceDto body, final String devEui) throws ApiException {
        com.squareup.okhttp.Call call = putEndDeviceValidateBeforeCall(body, devEui, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return this.apiClient.execute(call, localVarReturnType);
    }

    /**
     * putEndDevice (asynchronously)
     * This web service allows to create or update an end-device.&lt;br&gt;It returns an HTTP status 201 Created when a new end-device is created and an HTTP status 204 No-Content when an existing end-device is updated.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? ADMIN&lt;br&gt;&lt;br&gt;
     * @param body The DTO JSON representation to put in the request body (required)
     * @param devEui End-device EUI (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call putEndDeviceAsync(final EndDeviceDto body, final String devEui, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = putEndDeviceValidateBeforeCall(body, devEui, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        this.apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for resetEndDeviceFrameCounters
     * @param devEui End-device EUI (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call resetEndDeviceFrameCountersCall(final String devEui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/gms/application/endDevices/{devEui}/resetFrameCounters"
            .replaceAll("\\{" + "devEui" + "\\}", this.apiClient.escapeString(devEui.toString()));

        List<Pair> localVarQueryParams = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<>();

        Map<String, String> localVarHeaderParams = new HashMap<>();

        Map<String, Object> localVarFormParams = new HashMap<>();

        final String[] localVarAccepts = {
            "application/json", "application/vnd.kerlink.iot-v1+json"
        };
        final String localVarAccept = this.apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
			localVarHeaderParams.put("Accept", localVarAccept);
		}

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = this.apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            this.apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(final com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearer" };
        return this.apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call resetEndDeviceFrameCountersValidateBeforeCall(final String devEui, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'devEui' is set
        if (devEui == null) {
            throw new ApiException("Missing the required parameter 'devEui' when calling resetEndDeviceFrameCounters(Async)");
        }
        
        com.squareup.okhttp.Call call = resetEndDeviceFrameCountersCall(devEui, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * resetEndDeviceFrameCounters
     * This web service allows reset the fCntUp and fCntDown to 0.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void resetEndDeviceFrameCounters(final String devEui) throws ApiException {
        resetEndDeviceFrameCountersWithHttpInfo(devEui);
    }

    /**
     * resetEndDeviceFrameCounters
     * This web service allows reset the fCntUp and fCntDown to 0.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> resetEndDeviceFrameCountersWithHttpInfo(final String devEui) throws ApiException {
        com.squareup.okhttp.Call call = resetEndDeviceFrameCountersValidateBeforeCall(devEui, null, null);
        return this.apiClient.execute(call);
    }

    /**
     * resetEndDeviceFrameCounters (asynchronously)
     * This web service allows reset the fCntUp and fCntDown to 0.&lt;br&gt;&lt;br&gt;Since: v1.1.12&lt;br&gt;&lt;br&gt;Role ? USER&lt;br&gt;&lt;br&gt;
     * @param devEui End-device EUI (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call resetEndDeviceFrameCountersAsync(final String devEui, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(final long bytesRead, final long contentLength, final boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(final long bytesWritten, final long contentLength, final boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = resetEndDeviceFrameCountersValidateBeforeCall(devEui, progressListener, progressRequestListener);
        this.apiClient.executeAsync(call, callback);
        return call;
    }
}
